addHook("MobjMoveCollide", function(mo, mo2)
	if mo and mo.valid
	and mo2 and mo2.valid
	and mo.player and mo.player.valid
	and (mo2.flags & MF_MONITOR)
	and mo2.type ~= MT_EGGMAN_BOX
	and mo.z <= mo2.z+40*FU
		P_KillMobj(mo2, mo, mo)
	end
end)

freeslot("sfx_boxpop")
sfxinfo[sfx_boxpop].caption = "Pop"

addHook("MobjDeath", function(target, inflictor, source, damage)
	if inflictor and inflictor.valid
	and inflictor.player and inflictor.player.valid
	and target and target.valid
	and (target.flags & MF_MONITOR)
		S_StopSoundByID(inflictor, sfx_pop)
		S_StopSoundByID(target, sfx_pop)
		S_StartSound(inflictor, sfx_boxpop)
		local updust = P_SpawnMobj(target.x,target.y,target.z,MT_SPINDUST)
		updust.scale = FU/2
		P_SetObjectMomZ(updust, 3*FU)
		for i = 1, 2
			local dust = P_SpawnMobj(target.x,target.y,target.z+5*FU,MT_SPINDUST)
			dust.scale = FU/2
			P_InstaThrust(dust, ANGLE_90*i, 6*FU)
		end
	end
end)